//
// Window message constants
//
var wm_ALL                          = 0xFFFF;
var wm_NULL                         = 0x0000;
var wm_CREATE                       = 0x0001;
var wm_DESTROY                      = 0x0002;
var wm_MOVE                         = 0x0003;
var wm_SIZE                         = 0x0005;
var wm_SETFOCUS                     = 0x0007;
var wm_KILLFOCUS                    = 0x0008;
var wm_ENABLE                       = 0x000A;
var wm_SETREDRAW                    = 0x000B;
var wm_SETTEXT                      = 0x000C;
var wm_GETTEXT                      = 0x000D;
var wm_GETTEXTLENGTH                = 0x000E;
var wm_PAINT                        = 0x000F;
var wm_CLOSE                        = 0x0010;
var wm_QUERYENDSESSION              = 0x0011;
var wm_QUIT                         = 0x0012;
var wm_QUERYOPEN                    = 0x0013;
var wm_ERASEBKGND                   = 0x0014;
var wm_SYSCOLORCHANGE               = 0x0015;
var wm_ENDSESSION                   = 0x0016;
var wm_SHOWWINDOW                   = 0x0018;
var wm_WININICHANGE                 = 0x001A;
var wm_SETTINGCHANGE                = 0x001A;
var wm_DEVMODECHANGE                = 0x001B;
var wm_ACTIVATEAPP                  = 0x001C;
var wm_FONTCHANGE                   = 0x001D;
var wm_TIMECHANGE                   = 0x001E;
var wm_CANCELMODE                   = 0x001F;
var wm_SETCURSOR                    = 0x0020;
var wm_MOUSEACTIVATE                = 0x0021;
var wm_CHILDACTIVATE                = 0x0022;
var wm_QUEUESYNC                    = 0x0023;
var wm_GETMINMAXINFO                = 0x0024;
var wm_PAINTICON                    = 0x0026;
var wm_ICONERASEBKGND               = 0x0027;
var wm_NEXTDLGCTL                   = 0x0028;
var wm_SPOOLERSTATUS                = 0x002A;
var wm_DRAWITEM                     = 0x002B;
var wm_MEASUREITEM                  = 0x002C;
var wm_DELETEITEM                   = 0x002D;
var wm_VKEYTOITEM                   = 0x002E;
var wm_CHARTOITEM                   = 0x002F;
var wm_SETFONT                      = 0x0030;
var wm_GETFONT                      = 0x0031;
var wm_SETHOTKEY                    = 0x0032;
var wm_GETHOTKEY                    = 0x0033;
var wm_QUERYDRAGICON                = 0x0037;
var wm_COMPAREITEM                  = 0x0039;
var wm_COMPACTING                   = 0x0041;
var wm_WINDOWPOSCHANGING            = 0x0046;
var wm_WINDOWPOSCHANGED             = 0x0047;
var wm_POWER                        = 0x0048;
var wm_COPYDATA                     = 0x004A;
var wm_CANCELJOURNAL                = 0x004B;
var wm_NOTIFY                       = 0x004E;
var wm_INPUTLANGCHANGEREQUEST       = 0x0050;
var wm_INPUTLANGCHANGE              = 0x0051;
var wm_TCARD                        = 0x0052;
var wm_HELP                         = 0x0053;
var wm_USERCHANGED                  = 0x0054;
var wm_NOTIFYFORMAT                 = 0x0055;
var wm_CONTEXTMENU                  = 0x007B;
var wm_STYLECHANGING                = 0x007C;
var wm_STYLECHANGED                 = 0x007D;
var wm_DISPLAYCHANGE                = 0x007E;
var wm_GETICON                      = 0x007F;
var wm_SETICON                      = 0x0080;
var wm_NCCREATE                     = 0x0081;
var wm_NCDESTROY                    = 0x0082;
var wm_NCCALCSIZE                   = 0x0083;
var wm_NCHITTEST                    = 0x0084;
var wm_NCPAINT                      = 0x0085;
var wm_NCACTIVATE                   = 0x0086;
var wm_GETDLGCODE                   = 0x0087;
var wm_NCMOUSEMOVE                  = 0x00A0;
var wm_NCLBUTTONDOWN                = 0x00A1;
var wm_NCLBUTTONUP                  = 0x00A2;
var wm_NCLBUTTONDBLCLK              = 0x00A3;
var wm_NCRBUTTONDOWN                = 0x00A4;
var wm_NCRBUTTONUP                  = 0x00A5;
var wm_NCRBUTTONDBLCLK              = 0x00A6;
var wm_NCMBUTTONDOWN                = 0x00A7;
var wm_NCMBUTTONUP                  = 0x00A8;
var wm_NCMBUTTONDBLCLK              = 0x00A9;
var wm_KEYFIRST                     = 0x0100;
var wm_KEYDOWN                      = 0x0100;
var wm_KEYUP                        = 0x0101;
var wm_CHAR                         = 0x0102;
var wm_DEADCHAR                     = 0x0103;
var wm_SYSKEYDOWN                   = 0x0104;
var wm_SYSKEYUP                     = 0x0105;
var wm_SYSCHAR                      = 0x0106;
var wm_SYSDEADCHAR                  = 0x0107;
var wm_KEYLAST                      = 0x0108;
var wm_IME_STARTCOMPOSITION         = 0x010D;
var wm_IME_ENDCOMPOSITION           = 0x010E;
var wm_IME_COMPOSITION              = 0x010F;
var wm_IME_KEYLAST                  = 0x010F;
var wm_INITDIALOG                   = 0x0110;
var wm_COMMAND                      = 0x0111;
var wm_SYSCOMMAND                   = 0x0112;
var wm_TIMER                        = 0x0113;
var wm_HSCROLL                      = 0x0114;
var wm_VSCROLL                      = 0x0115;
var wm_INITMENU                     = 0x0116;
var wm_INITMENUPOPUP                = 0x0117;
var wm_MENUSELECT                   = 0x011F;
var wm_MENUCHAR                     = 0x0120;
var wm_ENTERIDLE                    = 0x0121;
var wm_CTLCOLORMSGBOX               = 0x0132;
var wm_CTLCOLOREDIT                 = 0x0133;
var wm_CTLCOLORLISTBOX              = 0x0134;
var wm_CTLCOLORBTN                  = 0x0135;
var wm_CTLCOLORDLG                  = 0x0136;
var wm_CTLCOLORSCROLLBAR            = 0x0137;
var wm_CTLCOLORSTATIC               = 0x0138;
var wm_MOUSEFIRST                   = 0x0200;
var wm_MOUSEMOVE                    = 0x0200;
var wm_LBUTTONDOWN                  = 0x0201;
var wm_LBUTTONUP                    = 0x0202;
var wm_LBUTTONDBLCLK                = 0x0203;
var wm_RBUTTONDOWN                  = 0x0204;
var wm_RBUTTONUP                    = 0x0205;
var wm_RBUTTONDBLCLK                = 0x0206;
var wm_MBUTTONDOWN                  = 0x0207;
var wm_MBUTTONUP                    = 0x0208;
var wm_MBUTTONDBLCLK                = 0x0209;
var wm_MOUSEWHEEL                   = 0x020A;
var wm_MOUSELAST                    = 0x020A;
var wm_PARENTNOTIFY                 = 0x0210;
var wm_ENTERMENULOOP                = 0x0211;
var wm_EXITMENULOOP                 = 0x0212;
var wm_SIZING                       = 0x0214;
var wm_CAPTURECHANGED               = 0x0215;
var wm_MOVING                       = 0x0216;
var wm_POWERBROADCAST               = 0x0218;
var wm_DEVICECHANGE                 = 0x0219;
var wm_IME_SETCONTEXT               = 0x0281;
var wm_IME_NOTIFY                   = 0x0282;
var wm_IME_CONTROL                  = 0x0283;
var wm_IME_COMPOSITIONFULL          = 0x0284;
var wm_IME_SELECT                   = 0x0285;
var wm_IME_CHAR                     = 0x0286;
var wm_IME_KEYDOWN                  = 0x0290;
var wm_IME_KEYUP                    = 0x0291;
var wm_MDICREATE                    = 0x0220;
var wm_MDIDESTROY                   = 0x0221;
var wm_MDIACTIVATE                  = 0x0222;
var wm_MDIRESTORE                   = 0x0223;
var wm_MDINEXT                      = 0x0224;
var wm_MDIMAXIMIZE                  = 0x0225;
var wm_MDITILE                      = 0x0226;
var wm_MDICASCADE                   = 0x0227;
var wm_MDIICONARRANGE               = 0x0228;
var wm_MDIGETACTIVE                 = 0x0229;
var wm_MDISETMENU                   = 0x0230;
var wm_ENTERSIZEMOVE                = 0x0231;
var wm_EXITSIZEMOVE                 = 0x0232;
var wm_DROPFILES                    = 0x0233;
var wm_MDIREFRESHMENU               = 0x0234;
var wm_MOUSEHOVER                   = 0x02A1;
var wm_MOUSELEAVE                   = 0x02A3;
var wm_CUT                          = 0x0300;
var wm_COPY                         = 0x0301;
var wm_PASTE                        = 0x0302;
var wm_CLEAR                        = 0x0303;
var wm_UNDO                         = 0x0304;
var wm_RENDERFORMAT                 = 0x0305;
var wm_RENDERALLFORMATS             = 0x0306;
var wm_DESTROYCLIPBOARD             = 0x0307;
var wm_DRAWCLIPBOARD                = 0x0308;
var wm_PAINTCLIPBOARD               = 0x0309;
var wm_VSCROLLCLIPBOARD             = 0x030A;
var wm_SIZECLIPBOARD                = 0x030B;
var wm_ASKCBFORMATNAME              = 0x030C;
var wm_CHANGECBCHAIN                = 0x030D;
var wm_HSCROLLCLIPBOARD             = 0x030E;
var wm_QUERYNEWPALETTE              = 0x030F;
var wm_PALETTEISCHANGING            = 0x0310;
var wm_PALETTECHANGED               = 0x0311;
var wm_HOTKEY                       = 0x0312


//
// Window style constants
//
var ws_OVERLAPPED           = 0x00000000;
var ws_POPUP                = 0x80000000;
var ws_CHILD                = 0x40000000;
var ws_MINIMIZE             = 0x20000000;
var ws_VISIBLE              = 0x10000000;
var ws_DISABLED             = 0x08000000;
var ws_CLIPSIBLINGS         = 0x04000000;
var ws_CLIPCHILDREN         = 0x02000000;
var ws_MAXIMIZE             = 0x01000000;
var ws_CAPTION              = 0x00C00000;
var ws_BORDER               = 0x00800000;
var ws_DLGFRAME             = 0x00400000;
var ws_VSCROLL              = 0x00200000;
var ws_HSCROLL              = 0x00100000;
var ws_SYSMENU              = 0x00080000;
var ws_THICKFRAME           = 0x00040000;
var ws_GROUP                = 0x00020000;
var ws_TABSTOP              = 0x00010000;
var ws_MINIMIZEBOX          = 0x00020000;
var ws_MAXIMIZEBOX          = 0x00010000;
var ws_TILED                = 0x00000000;
var ws_ICONIC               = 0x20000000;
var ws_SIZEBOX              = 0x00040000;
var ws_OVERLAPPEDWINDOW     = 0x00CF0000;
var ws_POPUPWINDOW          = 0x80880000;
var ws_CHILDWINDOW          = 0x40000000;
var ws_TILEDWINDOW          = 0x00CF0000;
var ws_EX_DLGMODALFRAME     = 0x00000001;
var ws_EX_NOPARENTNOTIFY    = 0x00000004;
var ws_EX_TOPMOST           = 0x00000008;
var ws_EX_ACCEPTFILES       = 0x00000010;
var ws_EX_TRANSPARENT       = 0x00000020;
var ws_EX_MDICHILD          = 0x00000040;
var ws_EX_TOOLWINDOW        = 0x00000080;
var ws_EX_WINDOWEDGE        = 0x00000100;
var ws_EX_CLIENTEDGE        = 0x00000200;
var ws_EX_CONTEXTHELP       = 0x00000400;
var ws_EX_RIGHT             = 0x00001000;
var ws_EX_LEFT              = 0x00000000;
var ws_EX_RTLREADING        = 0x00002000;
var ws_EX_LTRREADING        = 0x00000000;
var ws_EX_LEFTSCROLLBAR     = 0x00004000;
var ws_EX_RIGHTSCROLLBAR    = 0x00000000;
var ws_EX_CONTROLPARENT     = 0x00010000;
var ws_EX_STATICEDGE        = 0x00020000;
var ws_EX_APPWINDOW         = 0x00040000;
var ws_EX_OVERLAPPEDWINDOW  = 0x00000300;
var ws_EX_PALETTEWINDOW     = 0x00000188;

//
// Window redraw constants
//
var rdw_INVALIDATE          = 0x0001;
var rdw_INTERNALPAINT       = 0x0002;
var rdw_ERASE               = 0x0004;
var rdw_VALIDATE            = 0x0008;
var rdw_NOINTERNALPAINT     = 0x0010;
var rdw_NOERASE             = 0x0020;
var rdw_NOCHILDREN          = 0x0040;
var rdw_ALLCHILDREN         = 0x0080;
var rdw_UPDATENOW           = 0x0100;
var rdw_ERASENOW            = 0x0200;
var rdw_FRAME               = 0x0400;
var rdw_NOFRAME             = 0x0800;

//
// Class style constants
//
var cs_VREDRAW          = 0x0001;
var cs_HREDRAW          = 0x0002;
var cs_DBLCLKS          = 0x0008;
var cs_OWNDC            = 0x0020;
var cs_CLASSDC          = 0x0040;
var cs_PARENTDC         = 0x0080;
var cs_NOCLOSE          = 0x0200;
var cs_SAVEBITS         = 0x0800;
var cs_BYTEALIGNCLIENT  = 0x1000;
var cs_BYTEALIGNWINDOW  = 0x2000;
var cs_GLOBALCLASS      = 0x4000;

//
// Predefined window handles
//
var hwnd_BROADCAST = 0xffff;
var hwnd_DESKTOP   = 0;
var hwnd_TOP       = 0;
var hwnd_BOTTOM    = 1;
var hwnd_TOPMOST   = -1;
var hwnd_NOTOPMOST = -2;

//
// Window state constants
//
var sgRestored  = 1;
var sgMinimized = 2;
var sgMaximized = 3;

//
// Icon size constants
//
var sgSmall_16x16 = 16;
var sgBig_32x32   = 32;

//
// WM_PRINT constants
//
var prf_CHECKVISIBLE = 0x01;
var prf_NONCLIENT    = 0x02;
var prf_CLIENT       = 0x04;
var prf_ERASEBKGND   = 0x08;
var prf_CHILDREN     = 0x10;
var prf_OWNED        = 0x20;

//
// WindowLong index constants
//
var gwl_WNDPROC    = -4;
var gwl_HINSTANCE  = -6;
var gwl_HWNDPARENT = -8;
var gwl_STYLE      = -16;
var gwl_EXSTYLE    = -20;
var gwl_USERDATA   = -21;
var gwl_ID         = -12;
var dwl_DLGPROC    = 4;
var dwl_MSGRESULT  = 0;
var dwl_USER       = 8;

//
// Paint callback constants
//
var pfClientPaint        = 1;
var pfClientAfterDefault = 2;
var pfFramePaint         = 4;
var pfFrameAfterDefault  = 8;

